'' Spinpong - 2 player retro paddle game
'' JT Cook - http://www.avalondreams.com - 3-16-08
'' 
'' This game uses either 2 controllers or 2 mice
'' To use two mice plug 1 mouse into the keyboard port and the other in the mouse port
''
'' Other drivers used:
'' TV driver that supports either NTSC or PAL by Parallax and Jim Bagley
'' Frequency driver by Parallax
'' Mouse driver for Hydra and standard boards by Parallax
''
'' NOTE: Under the CON section, uncomment the section of code that is your Proppeller Hardware setup or
''   create your own settings. Also the mouse driver will be different if you using the Hydra (4 line per port)
''   or standard (2 line per port). See the OBJ section to change the driver
''
'' Todo: setup a ADC to read pots for the paddles
''
'' History
'' 3-16-08 - added sound
'' 3-09-08 - first release
''
CON
  PAL=%0001
  NTSC=%0000
  Hydra = 0
  Hybrid = 1
 ' joypad bit encodings
  JOY0_RIGHT  = %00000000_00000001
  JOY0_LEFT   = %00000000_00000010
  JOY0_DOWN   = %00000000_00000100
  JOY0_UP     = %00000000_00001000
  JOY0_START  = %00000000_00010000
  JOY0_SELECT = %00000000_00100000
  JOY0_B      = %00000000_01000000
  JOY0_A      = %00000000_10000000
  JOY1_RIGHT  = %00000001_00000000
  JOY1_LEFT   = %00000010_00000000
  JOY1_DOWN   = %00000100_00000000
  JOY1_UP     = %00001000_00000000
  JOY1_START  = %00010000_00000000
  JOY1_SELECT = %00100000_00000000
  JOY1_B      = %01000000_00000000
  JOY1_A      = %10000000_00000000

  JOY_SELECT_CLR = %00100000_00100000
  JOY_RIGHT_CLR  = %00000001_00000001
  JOY_LEFT_CLR   = %00000010_00000010
  ''placement of score numbers
  XScore1 = 5
  XScore2 = 24
  ''sound settings
  A_Counter = "B"
  miss_time = 25
  hit_time = 3
  bounce_time = 3
  miss_freq = 150
  hit_freq = 420
  bounce_freq = 150

''Custom hardware configurations
{ Hydra setup
  _clkmode = xtal1 + pll8x     ''Hydra
  _xinfreq = 10_000_000        ''Stock Hydra
'  _xinfreq = 10_000_000 + 5000 ''My Hydra
  _memstart = $50      ' memory starts $10 in!!! (this took 2 headaches to figure out)  
  Video_Pins  = %011_0000   ''pin location for video out
  V_NP = NTSC ''video type - NTSC or PAL
  ''setup pin groupings for audio
  Audio_Pins = %00000000_00000000_00000000_10000000               '- CTR   PLL -------- BPIN   --- APIN  
  Audio_Ctra = %0_00110_000_00000000_000000_000_000111

  Audio_Pin=7 ''for freq gen

  Console = Hydra
  ''setup data lines, NOTE: Hydra uses a different mouse driver
  Mouse_Data_Line=2
  Mouse_Clk_Line=0
  Keyboard_Data_Line=3
  Keyboard_Clk_Line=0 
   
}
 
{ Hybrid setup
  _clkmode = xtal1 + pll16x   
  _xinfreq = 6_000_000        
  _memstart = $10      ' memory starts $10 in!!! (this took 2 headaches to figure out)     
  Video_Pins  = %011_0000   ''pin location for video out
  V_NP = NTSC ''video type  - NTSC
  Console = Hybrid
  ''setup pin groupings for audio
  Audio_Pins = %00000000_00000000_00000000_10000000
               '- CTR   PLL -------- BPIN   --- APIN  
  Audio_Ctra = %0_00110_000_00000000_000000_000_000111

  Audio_Pin=7 ''for freq gen
    
  Mouse_Data_Line=12
  Mouse_Clk_Line=13
  Keyboard_Data_Line=14
  Keyboard_Clk_Line=15
  
}

'{ Demo/Proto board stup
  _clkmode = xtal1 + pll16x 
  _xinfreq = 5_000_000     
  _memstart = $10      ' memory starts $10 in!!! (this took 2 headaches to figure out)
  Video_Pins = %001_0101   ''pin location for video out
  V_NP = NTSC ''video type - NTSC
  Console = 0
  Audio_Pins = %00000000_00000000_00001100_00000000
               '- CTR   PLL -------- BPIN   --- APIN
  Audio_Ctra = %0_00110_000_00000000_000000_000_001010

  Audio_Pin=10 ''for freq gen
  
  Mouse_Data_Line=24
  Mouse_Clk_Line=25
  Keyboard_Data_Line=26
  Keyboard_Clk_Line=27 
     
'}


 ''used for video driver
 SCANLINE_BUFFER = $7F00           
 request_scanline       = SCANLINE_BUFFER-4  'address of scanline buffer for TV driver
 tilemap_adr            = SCANLINE_BUFFER-8  'address of tile map
 tile_adr               = SCANLINE_BUFFER-12 'address of tiles
 border_color           = SCANLINE_BUFFER-16 'address of border color 
 sprite_adr             = SCANLINE_BUFFER-20  'address of where sprites are stored
 sprite_x_adr           = SCANLINE_BUFFER-24 'X location of 8 sprites
 sprite_y_adr           = SCANLINE_BUFFER-32 'Y location of 8 sprites
 sprite_number          = SCANLINE_BUFFER-40 'address of images of 8 sprites
 sprite_x_flip          = SCANLINE_BUFFER-48 'flag to flip sprite on x axis
 sprite_y_flip          = SCANLINE_BUFFER-49 'flag to flip sprite on y axis
 Font_offset = 14 ''where font starts
 Screen_Cap = 1 ''1=enable screen capture, 0=disables screen capture
 
OBJ
  tv_game_gfx : "JTC_Tile_Drv.spin"  'JTC's Tile Driver
  i2c           : "Basic_I2C_Driver"
  joy : "gamepad.spin" 'controller objecet
  uart  : "FullDuplex.spin"  ' serial driver (for screen capture)
  Freq : "Synth" 'used for sound  
{
  ''Mouse driver for Hydra, setup different since each port has 4 lines
  mouse_left : "mouse_hydra.spin"     ' instantiate a mouse object
  mouse_right : "mouse_hydra.spin"     ' instantiate a mouse object
}  
'{
  ''Standard mouse driver 
  mouse_left : "mouse.spin"     ' instantiate a mouse object
  mouse_right : "mouse.spin"     ' instantiate a mouse object
'}
VAR
   long Tile_Map_Adr ''address to tilemap for graphics driver
   long TV_Type  ''NTSC or PAL
   long joypad ''joy pad
   long joypadold ''old status of joypad
   ''game based variables
   long Player1_X, Player1_Y, Player2_X, Player2_Y, Paddle_State, Hit_Counter,Score1, Score2
   long Ball_X, Ball_Y, Ball_X_Direction, Ball_Y_Direction, Ball_State, Temp_Ball, Ball_Counter
   long sound_counter              
PUB start | n, n2, Mouse_Y  

  ''set up graphics driver
  tv_game_gfx.Set_Border_Color($02) 'set border color
  ''NTSC or PAL
  if Console==Hybrid ''Hybrid stores NTSC/PAL val on flash rom
      i2c.ReadPage(28, $a0, $7fff, @TV_Type, 1)
  else
     TV_Type:=V_NP
  tv_game_gfx.start(Video_Pins,TV_Type) 'start graphics driver
  ''clear sound stuff
  Long[Tile_Adr]:=@TileFile 'grab address of tile graphics
  Long[Sprite_Adr]:=@SpriteFile 'grab address of sprite graphics
  Tile_Map_Adr:=LONG[CONSTANT($7F00-8)] 'grab address of tile map
  joy.Start(0,Console) ''setup to tell which controll set we are using
  'both keyboard and mouse ports are going to hold mice
  mouse_left.start(Mouse_Data_Line,Mouse_Clk_Line)
  mouse_right.start(Keyboard_Data_Line,Keyboard_Clk_Line)
  sound_counter:=0
  ''copy 1 bit font to 8 bit tiles

  repeat n from 0 to 90 ''90
    tv_game_gfx.Convert_Tile(@Char_data, n+Font_Offset,n, $02, $06)


  ''clear screen
  repeat n from 0 to CONSTANT((32*24)-1)
    byte[Tile_Map_Adr+n]:=0
    
  ''show intro text screen, only shown once
 Print_String(1,6,@TitleText)
 Print_String(6,22,@DemoText)
 Print_String(0,23,@DateText)                 
 Print_String(1,8,@Start1Text)
 Print_String(1,9,@Start2Text)
 Print_String(1,11,@Start3Text)
 Print_String(1,12,@Start4Text) 
 Print_String(1,13,@Start5Text)
 Print_String(1,14,@Start6Text) 
 Print_String(1,16,@Start7Text)
 
  
  ''setup game
  Init_Game
       
  repeat
   tv_game_gfx.Wait_Vsync ''wait for vertical retrace
    ''read gamepad
    joypad := joy.Read_Gamepad
    if((joypad & JOY0_DOWN) <> 0)
      Player1_Y+=3
    if((joypad & JOY0_UP) <> 0)
      Player1_Y-=3
    if((joypad & JOY1_DOWN) <> 0)
      Player2_Y+=3      
    if((joypad & JOY1_UP) <> 0)
      Player2_Y-=3     
           
    if((joypad & JOY0_SELECT) <> 0 AND Screen_Cap==1)
       Screen_Grab
    ''start a new game if we are not already in one
    if(Paddle_State==0)
      if((joypad & JOY0_B) <> 0 OR (joypad & JOY1_B) <> 0 OR (mouse_left.button(0)&1) == 1 OR (mouse_right.button(0)&1) == 1)
         New_Game
    Player1_Y-=mouse_right.delta_y
    Player2_Y-=mouse_left.delta_y
    Player1_Y&=$FF
    Player2_Y&=$FF    
    Game_Loop    
    joypadold:=joypad ''buffer joypad info for checking taps
PUB Init_Game | n, n2
     ''set sprite image of paddls
     BYTE[sprite_number]:=0  
     BYTE[sprite_number-1]:=0
     ''set sprite image of ball
     BYTE[sprite_number-2]:=1
     Player1_X:=14
     Player1_Y:=50
     Player2_X:=CONSTANT(255-16-14)
     Player2_Y:=50
     Ball_X:=100
     Ball_Y:=20
     Ball_State:=1 ''turn ball on
     Ball_X_Direction:=CONSTANT(1 | 128) ''direction of ball on X axis - 7th bit will be sign bit
     Ball_Y_Direction:=1 ''direction of ball on Y axis - 7th bit will be sign bit
     Paddle_State:=0 ''turn paddles off
     Score1:=0
     Score2:=0
     Hit_Counter:=0 ''used to speed up ball in play
     Ping_Number(XScore1,1,Score1)
     Ping_Number(XScore2,1,Score2)       
PUB New_Game |n2,n
     Ball_Counter:=1
     Ball_State:=0
     Paddle_State:=1
     Score1:=0
     Score2:=0
     Hit_Counter:=0 ''used to speed up ball in play

     ''clear screen
     repeat n from 0 to CONSTANT((32*24)-1)
       byte[Tile_Map_Adr+n]:=0
    
     ''draw net
     n2:=15
     repeat n from 0 to 23
         byte[Tile_Map_Adr+n2]:=1
      n2+=32

     Ping_Number(XScore1,1,Score1)
     Ping_Number(XScore2,1,Score2)               
PUB Game_Loop | n
  '' Ball Handling ---------------------------------------------------------------
  ''check if ball hits right side of screen
  if(Ball_X>CONSTANT(255-4))
     Ball_X_Direction:=1 ''change back to original speed
     Ball_X_Direction|=128 ''set 7th bit, move ball left
    ''are we in a game?
    if(Paddle_State>0)
     Ball_State:=0 ''turn off ball graphic
     Hit_Counter:=0 ''used to speed up ball in play, reset back to zero
     ''used between plays when ball is hidden
     if(Ball_Counter>0)
       Ball_Counter--
     else ''if ball is not hidden then start counter, 
       Ball_Counter:=1
       Score1++
       Ping_Number(XScore1,1,Score1)
       Freq.Synth(A_Counter,  Audio_Pin, miss_freq) ''miss
       sound_counter:=miss_time       
     ''check game over
     if Score1>10
       Paddle_State:=0
       Ball_State:=1 ''turn ball back on
       'set ball back to normal angle
       Ball_Y_Direction:=(Ball_Y_Direction|1)&129
       
  ''check left side of screen
  elseif(Ball_X<1)
     Ball_X_Direction:=1 ''change back to original speed
     Ball_X_Direction &= 1 ''remove 7th bit, move ball right
    ''are we in a game?     
    if(Paddle_State>0)
     Ball_State:=0 ''turn off ball graphic
     Hit_Counter:=0 ''used to speed up ball in play, reset back to zero  
     ''used between plays when ball is hidden
     if(Ball_Counter>0)
       Ball_Counter--
     else ''if ball is not hidden then start counter, 
       Ball_Counter:=1
       Score2++
       Ping_Number(XScore2,1,Score2)
       Freq.Synth(A_Counter,Audio_Pin, miss_freq) ''miss
       sound_counter:=miss_time       
     ''check game over
     if Score2>10
       Paddle_State:=0
       Ball_State:=1 ''turn ball back on
       Ball_Y_Direction:=(Ball_Y_Direction|1)&129

  '' check if ball is turned off
  if(Ball_State==0)
     if(Ball_Counter<1 AND Ball_X>120 AND Ball_X<125) ''turn back on when we get to middle of screen
       Ball_State:=1 ''turn ball on      
  '' Move ball
  if(Ball_X_Direction & 128)
     Ball_X-=Ball_X_Direction & 7
  else
     Ball_X+=Ball_X_Direction & 7
  ''Check Y Limits on ball
  if(Ball_Y>CONSTANT(192+16-4))
     Ball_Y_Direction |= 128 ''set 7th bit, move left
     if(paddle_state>0 AND ball_state>0)
            Freq.Synth(A_Counter,Audio_Pin, bounce_freq) ''miss
            sound_counter:=bounce_time       
  elseif(Ball_Y<16)
     Ball_Y_Direction &= 3 '' remove 7th bit, move right
     if(paddle_state>0 AND ball_state>0)
            Freq.Synth(A_Counter,Audio_Pin, bounce_freq) ''miss
            sound_counter:=bounce_time       
  '' move ball
  if(Ball_Y_Direction & 128)
     Ball_Y-=Ball_Y_Direction & 3
  else
     Ball_Y+=Ball_Y_Direction & 3

  ''Paddle Handling -------------------------------------------------------------
  if(Paddle_State AND Ball_State)
  ''if( 1 == 1)
    ''check left paddle
    if Ball_X + 4 > Player1_X AND Ball_X < Player1_X + 4
      if Ball_Y + 4 > Player1_Y AND Ball_Y < Player1_Y + 14
         if(sound_counter<1)         
           Freq.Synth(A_Counter,Audio_Pin, hit_freq) ''hit
           sound_counter:=hit_time
        'find angle of hit ball
         Temp_Ball:=(Ball_Y-Player1_Y) >> 1
         if(Temp_Ball>7)
           Temp_Ball:=7         
         Ball_Y_Direction:=Byte[@Angle_LUT+Temp_Ball] ''debug
         if(Hit_Counter<14)           
            Hit_Counter++ ''used to speed up ball in play
            Ball_X_Direction:=Byte[@Ball_Speed_Lut+Hit_Counter]
         Ball_X_Direction &= 7 ''move ball to the right

    ''check right paddle
    if Ball_X+4 > Player2_X AND Ball_X < Player2_X + 4
       if Ball_Y+4 > Player2_Y AND Ball_Y < Player2_Y+14
         if(sound_counter<1)         
           Freq.Synth(A_Counter,Audio_Pin, hit_freq) ''hit
           sound_counter:=hit_time
         sound_counter:=hit_time
         Temp_Ball:=(Ball_Y-Player2_Y) >> 1
         if(Temp_Ball>7)
           Temp_Ball:=7         
         Ball_Y_Direction:=Byte[@Angle_LUT+Temp_Ball] ''debug           
         if(Hit_Counter<14)           
            Hit_Counter++ ''used to speed up ball in play
            Ball_X_Direction:=Byte[@Ball_Speed_Lut+Hit_Counter]

         Ball_X_Direction|= 128 ''move ball to the left
         
  ''setup sprite coords
  if(Paddle_State)
    BYTE[sprite_x_adr]:=Player1_X
    BYTE[sprite_y_adr]:=Player1_Y
    BYTE[sprite_x_adr-1]:=Player2_X
    BYTE[sprite_y_adr-1]:=Player2_Y
  else
    BYTE[sprite_y_adr]:=0
    BYTE[sprite_y_adr-1]:=0
  if(Ball_State)
    BYTE[sprite_x_adr-2]:=Ball_X
    BYTE[sprite_y_adr-2]:=Ball_Y
  else
    BYTE[sprite_y_adr-2]:=0

  ''check to see if we clear sound or not
  if(sound_counter>0)
    sound_counter--
    if(sound_counter==0)
     Freq.Synth(A_Counter,Audio_Pin, 0) ''clear sound     

PUB Ping_Number(xn,yn,nnumber) | offset, offset2
  'nnumber&=$F ''mask off number
  offset:=(yn*32)+xn  ''get screen position for number
  offset2:=nnumber << 3 ''find number tile map
  ''handl left digit as a 1
  if(nnumber>9)
   nnumber-=10
   offset2:= nnumber << 3 ''grab new tile map address that is less than 10 for right digit
   byte[Tile_Map_Adr+offset]:=5
   byte[Tile_Map_Adr+32+offset]:=5
   byte[Tile_Map_Adr+(32*2)+offset]:=5
   byte[Tile_Map_Adr+(32*3)+offset]:=13
  else ''if number is less than 10, make sure there is no 1 digit
   byte[Tile_Map_Adr+offset]:=0
   byte[Tile_Map_Adr+32+offset]:=0
   byte[Tile_Map_Adr+(32*2)+offset]:=0
   byte[Tile_Map_Adr+(32*3)+offset]:=0

  offset+=2 ''handl right digit

  byte[Tile_Map_Adr +offset]:=byte[@Number_LUT+offset2]
  byte[Tile_Map_Adr + 1 + offset]:=byte[@Number_LUT+1+offset2]
  byte[Tile_Map_Adr + 32 + offset]:=byte[@Number_LUT+2+offset2]
  byte[Tile_Map_Adr + 33 + offset]:=byte[@Number_LUT+3+offset2]
  byte[Tile_Map_Adr + 64 + offset]:=byte[@Number_LUT+4+offset2]  
  byte[Tile_Map_Adr + 65 + offset]:=byte[@Number_LUT+5+offset2]
  byte[Tile_Map_Adr + 96 + offset]:=byte[@Number_LUT+6+offset2]
  byte[Tile_Map_Adr + 97 + offset]:=byte[@Number_LUT+7+offset2]
  
     
PUB Check_Tap_Key(key_hit)
  ''check joy pad 1
  if(key_hit<$0100)
   if(((joypad & key_hit & $00FF) & ((joypadold & key_hit & $00FF)^ key_hit)) <> 0)
    return 1
  ''check joy pad 2
  if(key_hit>$00FF)
   if(((joypad & key_hit & $FF00) & ((joypadold & key_hit & $FF00)^ key_hit)) <> 0)
    return 1
  else
    return 0

PUB Print_String(x,y,adr) | n, text_adr
'' prints a string
  n:=0
  text_adr:=adr
  repeat until byte[text_adr+n] == 0
    tv_game_gfx.Place_Tile_XY(x+n,y,byte[text_adr+n]+Font_offset-32) ''write characer
    n++

PUB Screen_Grab | current_line, pixel_adr, cur_pixel, pixel_4,packet
  '' Stop the TV driver, send 16 bits of X pixel width, send 16 bits of Y pixel
  ''    height, send the screen data, then when all is finished send $FF to tell
  ''    client no more pixel data is coming. After that is done start up the TV
  ''    driver.
  '' The TV driver and serial driver share a COG, but since only one is used at a time
  '' we will start the serial COG after the TV COG is stopped. When we are finished sending
  '' the image, then we will shut off the serial COG and start up the TV COG
  tv_game_gfx.tv_stop
   repeat 50000 ' Give some time between TV cog stopping and serial cog starting  

  uart.start(31, 30, 115200) 'start serial driver for screen capture

  ''send X screen width - 16 bits big endian
  uart.tx($01) ''256
  uart.tx($00)
  ''send Y screen length - 16 bits big endian
  uart.tx($00) ''192
  uart.tx($C0) ''$C0
  
  ''send screen data   
  current_line:=0
  repeat 192
    long[request_scanline]:= current_line
    pixel_adr:=SCANLINE_BUFFER
    ''pixel_adr+=(255-32)
    ''read scanline and send scanline
    repeat 256
    ''+2 added because TV driver adds this when it renders the signal
     cur_pixel:=byte[pixel_adr]''+2 
     pixel_adr+=1
     uart.tx(cur_pixel) ' - send byte
     {
     '' this will loop until we receive a valid byte
     repeat
       packet:=uart.rxcheck
     while packet==-1  'wait until valid byte is received
      }
   current_line+=1
  uart.tx($FF) ' - all done
  
   repeat 10000 ' delay it, make sure last byte is sent before we shut it down
  uart.stop ''stop serial cog

   repeat 100000 ' Give some time between serial cog stopping and TV cog starting   
  tv_game_gfx.tv_start
  
DAT
 ''sprite graphics
SpriteFile file "pong.spr"
 ''tile graphics
TileFile file "pong.til"

''Look up table for ball direction when hit against paddles
Angle_LUT
byte 128+3, 128+2, 128+1,0,1,2,3,128+3
''find how fast the ball should be going after every hit
Ball_Speed_Lut
byte 1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4
''used to translate tiles into numbers on the screen, 0-9
Number_LUT
byte 2, 3, 4, 5, 4, 5, 6, 7 ''0
byte 0, 5, 0, 5, 0, 5, 0,13 ''1
byte 8, 3,10,12, 4, 0, 6, 9 ''2
byte 8, 3,10,12, 0, 5, 9, 7 ''3
byte 4, 5,11,12, 0, 5, 0,13 ''4
byte 2, 8,11,10, 0, 5, 9, 7 ''5
byte 2, 8,11,10, 4, 5, 6, 7 ''6
byte 8, 3, 0, 5, 0, 5, 0,13 ''7
byte 2, 3,11,12, 4, 5, 6, 7 ''8
byte 2, 3,11,12, 0, 5, 0,13 ''9
byte 0, 0, 0, 0, 0, 0, 0, 0 ''blank
''Opening screen text
TitleText
byte "Spinpong",0
Start1Text
byte "Play with either 2 joypads",0
Start2Text
byte "or with 2 mice.",0
Start3Text
byte "To play with 2 mice plug 1",0
Start4Text
byte "mouse into the mouse port",0
Start5Text
byte "and the other into the",0
Start6Text
byte "keyboard port",0
Start7Text
byte "Hit the button to start!",0
DateText
byte "03/16/08 - JT Cook",0
DemoText
byte "WWW.AVALONDREAMS.COM",0



Char_data
'enter, special characters
byte 0,0,0,0,0,0,0,0 ' Enter/Clear - 32              
byte 24,24,24,24,0,0,24,0 ' ! - 33
byte 102,102,102,0,0,0,0,0 ' " - 34
byte 102,102,255,102,255,102,102,0 ' # - 35
byte 24,62,96,60,6,124,24,0 '$ - 36
byte 98,102,12,24,48,102,70,0' % - 37
byte 60,102,60,56,103,102,63,0 ' & - 38
byte 6,12,24,0,0,0,0,0 ' ' - 39              
byte 12,24,48,48,48,24,12,0 ' ( - 40
byte 48,24,12,12,12,24,48,0 ' ) - 41
byte 0,102,60,255,60,102,0,0 ' * - 42
byte 0, 24,24,126,24,24,0,0 ' +  - 43
byte 0,0,0,0,0,24,24,48 ' ,  44
byte 0,0,0,126,0,0,0,0 ' - - 45
byte 0,0,0,0,0,24,24,0 ' . - 46              
byte 0,3,6,12,24,48,96,0 ' / - 47
'Numbers 0-9
byte 60,102,110,118,102,102,60,0 ' 0 - 48
byte 24,24,56,24,24,24,126,0 ' 1 - 49
byte 60,102,6,12,48,96,126,0 ' 2 - 50
byte 60,102,6,28,6,102,60,0 ' 3 - 51
byte 6,14,22,102,127,6,6,0 ' 4 - 52
byte 126,96,124,6,6,102,60,0 ' 5 - 53              
byte 60,102,96,124,102,102,60,0 ' 6 - 54
byte 126,102,12,12,12,12,12,0 ' 7 - 55
byte 60,102,102,60,102,102,60,0 ' 8 - 56
byte 60,102,102,62,6,102,60,0 ' 9 - 57
'special characters
byte 0,0,24,0,0,24,0,0 ' : - 58
byte 0,0,24,0,0,24,24,48 ' ; - 59
byte 14,24,48,96,48,24,14,0 ' < - 60
byte 0,0,126,0,126,0,0,0 ' = - 61
byte 112,24,12,6,12,24,112,0 ' > - 62
byte 60,102,6,12,24,0,24,0 ' ? - 63
byte 60,102,110,110,96,98,60,0 ' @ - 64
'A-Z upper case
byte 24,60,102,126,102,102,102,0 ' A - 65
byte 124,102,102,124,102,102,124,0 ' B - 66
byte 60,102,96,96,96,102,60,0 ' C - 67
byte 120,108,102,102,102,108,120,0 ' D - 68
byte 126,96,96,120,96,96,126,0 ' E - 69
byte 126,96,96,120,96,96,96,0 ' F - 70
byte 60,102,96,110,102,102,60,0 ' G - 71
byte 102,102,102,126,102,102,102,0 ' H - 72
byte 60,24,24,24,24,24,60,0 'I - 73
byte 30,12,12,12,12,108,56,0 ' J - 74
byte 102,108,120,112,120,108,102,0 ' K - 75
byte 96,96,96,96,96,96,126,0 ' L - 76
byte 99,119,127,107,99,99,99,0 ' M - 77
byte 102,118,126,110,102,102,102,0 ' N - 78
byte 60,102,102,102,102,102,60,0 ' O - 79
byte 124,102,102,124,96,96,96,0 ' P - 80
byte 60,102,102,102,102,102,60,14 ' Q - 81
byte 124,102,102,124,120,108,102,0 ' R - 82
byte 60,102,96,60,6,102,60,0 ' S - 83
byte 126,24,24,24,24,24,24,0 ' T - 84
byte 102,102,102,102,102,102,60,0 ' U - 85
byte 102,102,102,102,102,60,24,0 ' V - 86
byte 99,99,99,107,127,119,99,0 ' W - 87
byte 102,102,60,24,60,102,102,0 ' X - 88
byte 102,102,102,60,24,24,24,0 ' Y - 89
byte 126,6,12,24,48,112,126,0 ' Z - 90
'special characters
byte 60,48,48,48,48,48,60,0 ' [ - 91
byte 0,96,48,24,12,6,3,0 ' \ - 92
byte 60,12,12,12,12,12,60,0 ' ] - 93
byte 24,60,102,0,0,0,0,0 ' ^ - 94
byte 0,0,0,0,0,0,255,0 ' _ - 95
byte 96,48,24,0,0,0,0,0 ' ` - 96
'a-z lower case
byte 0,0,60,6,62,102,62,0 'a - 97
byte 0,96,96,124,102,102,124,0 ' b - 98
byte 0,0,60,96,96,96,60,0 ' c - 99
byte 0,6,6,62,102,102,62,0 ' d - 100
byte 0,0,60,102,126,96,60,0 ' e - 101
byte 0,14,24,62,24,24,24,0 ' f - 102
byte 0,0,62,102,102,62,6,124 ' g - 103
byte 0,96,96,124,102,102,102,0 ' h - 104
byte 0,24,0,56,24,24,60,0 ' i -105
byte 0,6,0,6,6,6,6,60 ' j -106
byte 0,96,96,108,120,108,102,0 ' k - 107
byte 0,56,24,24,24,24,60,0 ' l - 108
byte 0,0,102,127,127,107,99,0 ' m - 109
byte 0,0,124,102,102,102,102,0 ' n - 110
byte 0,0,60,102,102,102,60,0 ' o - 111
byte 0,0,124,102,102,124,96,96 ' p - 112
byte 0,0,62,102,102,62,6,6 ' q - 113
byte 0,0,124,102,96,96,96,0 ' r - 114
byte 0,0,62,96,60,6,124,0 ' s - 115
byte 0,24,126,24,24,24,14,0 ' t - 116
byte 0,0,102,102,102,102,62,0 ' u - 117
byte 0,0,102,102,102,60,24,0 ' v - 118
byte 0,0,99,107,127,62,54,0 ' w - 119
byte 0,0,102,60,24,60,102,0 ' x - 120
byte 0,0,102,102,102,62,12,120' y - 121
byte 0,0,126,12,24,48,126,0 ' z - 122